'=========================================================================
' TV Guide (v0.2)
'=========================================================================
'
' My first attempt at a television guide plugin.
' Retrieves Program name, Start Time, Synopsis for any channel any time
' for the current day
' 					                       - mnorth
'
'=========================================================================
' VARIABLES :
'=========================================================================
'
' ChannelID: Sky ID of the channel
' ProgramDisplacement: Move forward or back the selected number of 
' programs
'
'=========================================================================

'Gets the program synopsis
Function GetProgramDescription(ChannelID, ProgramDisplacement)
	GetProgramDescription = ReturnItem(ChannelID, _
							ProgramDisplacement, _
							"Programme(synopsis, programmeName)", _
							"</script>", _
							"new Programme('", _
							"',")
End Function

'Retrieves the program name
Function GetProgramName(ChannelID, ProgramDisplacement)
	GetProgramName = ReturnItem(ChannelID, _
						ProgramDisplacement, _
						"<div id=""tvguide-listings"" class=""grey-panel"">", _
						"</div>", _
						"title=""View synopsis of this programme"">", _
						"</a>")
End Function

'Retrieves the program start time
Function GetProgramStartTime(ChannelID, ProgramDisplacement)
	GetProgramStartTime= ReturnItem(ChannelID, _
						ProgramDisplacement, _
						"<div id=""tvguide-listings"" class=""grey-panel"">", _
						"</div>", _
						"<td width=""20%"" class=""time"">", _
						"</td>")
End Function

'Retrieves the program end time
Function GetProgramEndTime(ChannelID, ProgramDisplacement)
	GetProgramEndTime= ReturnItem(ChannelID, _
						ProgramDisplacement + 1, _
						"<div id=""tvguide-listings"" class=""grey-panel"">", _
						"</div>", _
						"<td width=""20%"" class=""time"">", _
						"</td>")
End Function

'Retrieves the program progress
Function GetProgramProgress(ChannelID)
	On Error Resume Next
	Dim StartTime, EndTime
	
	'sets defualt value
	If ProgramDisplacement < 0 Then
		GetProgramProgress = 100
	Else
		GetProgramProgress = 0
	End If
	StartTime = ReturnItem(ChannelID, _
					0, _
					"<div id=""tvguide-listings"" class=""grey-panel"">", _
					"</div>", _
					"<td width=""20%"" class=""time"">", _
					"</td>")
	EndTime = ReturnItem(ChannelID, _
					1 , _
					"<div id=""tvguide-listings"" class=""grey-panel"">", _
					"</div>", _
					"<td width=""20%"" class=""time"">", _
					"</td>")
	If IsDate(StartTime) And IsDate(EndTime) And Time => CDate(StartTime) And Time <= CDate(EndTime)Then
		GetProgramProgress = (Time - CDate(StartTime)) / (CDate(EndTime) - CDate(StartTime)) * 100
	Elseif Time => CDate(EndTime) Then
		GetProgramProgress = 100	
	End If
End Function

' Gets the HTML string from the web page
Private Function ReturnHTML(ChannelID, StartMain, EndMain)
	Dim objXMLHTTP, url
	Set objXMLHTTP = CreateObject("Microsoft.XMLHTTP")
	objXMLHTTP.Open "GET", "http://www.sky.com/ordersky/tvguide/0,," & ChannelID & "-0,00.html", False
	objXMLHTTP.Send

	'Selects On the string To search In
	startPos = 1
	startPos = InStr(startPos, objXMLHTTP.responsetext, StartMain)
	endPos = InStr(startPos, objXMLHTTP.responsetext, EndMain) - startPos
	ReturnHTML = Mid(objXMLHTTP.responsetext, startPos, endPos)

	Set objXMLHTTP = Nothing
End Function

'seaches the page and returns the id of the currently playing program
Private Function ReturnProgram(HTMLString)
	Dim ProgramTime, CurrentProgram, CurrentDate
    
	'GETS ARRAY OF TIMES
	startPos = 1
	CurrentDate = Date
	Redim ProgramTime(0)
	Do While InStr(startPos, HTMLString, "<td width=""20%"" class=""time"">") > 0
		'GETS THE TIME
		posOne = InStr(startPos, HTMLString, "<td width=""20%"" class=""time"">") + 29
		posTwo = InStr(posOne, HTMLString, "</td>")
		If posOne > 0 And posTwo > posOne Then
			ProgramTime(UBound(ProgramTime)) = Right(Mid(HTMLString, posOne, posTwo - posOne), posTwo - posOne)
			If ProgramTime(UBound(ProgramTime)) > "00:00" And ProgramTime(UBound(ProgramTime)) < "06:00" Then CurrentDate = DateAdd("d", 1, Date)
			'If CDate(CurrentDate & " " & ProgramTime(UBound(ProgramTime))) < Date & " " & Time Then CurrentProgram = (UBound(ProgramTime))
			If CDate(CurrentDate) <= Date And CDate(ProgramTime(UBound(ProgramTime))) < Time Then CurrentProgram = (UBound(ProgramTime))
			Redim Preserve ProgramTime(UBound(ProgramTime) + 1)
		End If
		startPos = posTwo
	Loop
	Redim Preserve ProgramTime(UBound(ProgramTime) - 1)
    
	ReturnProgram = CurrentProgram
End Function

Private Function ReturnItem(ChannelID, ProgramDisplacement, StartMain, EndMain, StartItem, EndItem)
	Dim ProgramItem, HTMLString, CurrentProgram
    
	CurrentProgram = ReturnProgram(ReturnHTML(ChannelID, "<div id=""tvguide-listings"" class=""grey-panel"">", "</div>"))
    
	'GETS ARRAY OF TIMES
	HTMLString = ReturnHTML(ChannelID, StartMain, EndMain)
	startPos = 1
	CurrentDate = Date
	Redim ProgramItem(0)
	Do While InStr(startPos, HTMLString, StartItem) > 0
		'GETS THE TIME
		posOne = InStr(startPos, HTMLString, StartItem) + Len(StartItem)
		posTwo = InStr(posOne, HTMLString, EndItem)
		If posOne > 0 And posTwo > posOne Then
			ProgramItem(UBound(ProgramItem)) = Right(Mid(HTMLString, posOne, posTwo - posOne), posTwo - posOne)
			Redim Preserve ProgramItem(UBound(ProgramItem) + 1)
		End If
		startPos = posTwo
	Loop
	Redim Preserve ProgramItem(UBound(ProgramItem) - 1)
    
    	If CurrentProgram + ProgramDisplacement => Lbound(ProgramItem) And CurrentProgram + ProgramDisplacement <= Ubound(ProgramItem) Then
		ReturnItem = ProgramItem(CurrentProgram + ProgramDisplacement)
	Else
		ReturnItem = "No information could be found"
	End If
End Function